# NOTE: Derived from blib/lib/Class/MethodMaker.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Class::MethodMaker;

#line 1706 "blib/lib/Class/MethodMaker.pm (autosplit into blib/lib/auto/Class/MethodMaker/hash_of_lists.al)"
# ----------------------------------------------------------------------


sub hash_of_lists {
  my ($class, @args) = @_;
  my %methods;

  foreach (@args) {
    my $field = $_;

    $methods{$field} =
      sub {
        my ($self, @list) = @_;
        # defined $self->{$field} or $self->{$field} = {};

        my @Result;

        if ( @list ) {
          if ( @list == 1 and ref ($list[0]) eq 'ARRAY' ) {
            @Result = map @$_, @{$self->{$field}}{@{$list[0]}};
          } else {
            my @keys =
              map ref ($_) eq 'ARRAY' ? @$_: $_,
                grep exists $self->{$field}{$_}, @list;
            @Result = map @$_, @{$self->{$field}}{@keys};
          }
        } else {
          @Result = map @$_, values %{$self->{$field}};
        }

        return wantarray ? @Result : \@Result;
      };

    $methods{$field . "_keys"} =
      sub {
        my ($self) = shift;
        my @Result = keys %{$self->{$field}};
        return wantarray ? @Result : \@Result;
      };

    $methods{$field . "_exists"} =
      sub {
        my ($self) = shift;
        my (@keys) = @_;
        my $found = exists $self->{$field};
        for (@keys) {
          $found &&= exists $self->{$field}->{$_};
        }
        return $found;
      };

    $methods{$field . "_delete"} =
      sub {
        my ($self, @keys) = @_;
        delete @{$self->{$field}}{@keys};
      };

    $methods{$field . "_push"} =
      sub {
        my ($self, $key, @values) = @_;
        my @keys = ref ($key) eq 'ARRAY' ? @$key : $key;
        for (@keys) {
          push @{$self->{$field}{$_}}, @values;
        }
      };

    $methods{$field . "_unshift"} =
      sub {
        my ($self, $key, @values) = @_;
        my @keys = ref ($key) eq 'ARRAY' ? @$key : $key;
        for (@keys) {
          unshift @{$self->{$field}{$_}}, @values;
        }
      };

    $methods{$field . "_pop"} =
      sub {
        my ($self, @keys) = @_;
        my @old;
        for (@keys) {
          push @old, pop @{$self->{$field}{$_}};
        }
        return @old;
      };

    $methods{$field . "_shift"} =
      sub {
        my ($self, @keys) = @_;
        my @old;
        for (@keys) {
          push @old, shift @{$self->{$field}{$_}};
        }
        return @old;
      };

    $methods{$field . "_splice"} =
      sub {
        my ($self, $key, $offset, $length, @values) = @_;
        splice @{$self->{$field}{$key}}, $offset, $length, @values;
      };

    $methods{$field . "_clear"} =
      sub {
        my ($self, @keys) = @_;
        for (@keys) {
          $self->{$field}{$_} = [];
        }
      };

    $methods{$field . "_count"} =
      sub {
        my ($self, @keys) = @_;
        my $Result = 0;
        # Avoid autovivifying additional entries.
        for (@keys) {
          $Result +=
            exists $self->{$field}{$_} ?
              scalar @{$self->{$field}{$_}} : 0;
        }
        return $Result;
      };

    $methods{"${field}_index"} =
      sub {
        my ($self, $key_r, @indices) = @_;
        my (@Result, $index, $key);
        my @keys = ref ($key_r) eq 'ARRAY' ? @$key_r : $key_r;
        foreach $key (@keys) {
          my $ary = $self->{$field}{$key};
          foreach $index (@indices) {
            push @Result,
              ( @{$ary} > $index ) ? $ary->[$index] : undef;
          }
        }
        return wantarray ? @Result : \@Result;
      };

    $methods{"${field}_remove"} =
      sub {
        my ($self, $key_r, @indices) = @_;
        my ($index, $key);
        my @keys = ref ($key_r) eq 'ARRAY' ? @$key_r : $key_r;
        foreach $key (@keys) {
          my $ary = $self->{$field}{$key};
          foreach $index (sort {$b<=>$a} grep $_ < @$ary, @indices) {
            splice (@$ary, $index, 1);
          }
        }
        return;
      };

    $methods{"${field}_sift"} =
      sub {
        my $self = shift;
        my %args;
        if ( @_ == 1 and ref $_[0] eq 'HASH' ) {
          %args = %{$_[0]};
        } else {
          %args = @_;
        }
        my $filter_sr = $args{'filter'}  || sub { $_[0] == $_[1] };
        my $keys_ar   = $args{'keys'}    || keys %{$self->{$field}};
        my $values_ar = $args{'values'}  || [undef];
# This is harder than it looks; reverse means we want to grep out only
# if *none* of the values matches.  I guess an evaled block, or closure
# or somesuch is called for.
#       my $reverse   = $args{'reverse'} || 0;

        my ($key, $i, $value);
      KEY:
        foreach $key (@$keys_ar) {
          next KEY
            unless exists $self->{$field}{$key};
        INDEX:
          for ($i = $#{$self->{$field}{$key}}; $i >= 0; $i--) {
            foreach $value (@$values_ar) {
              if ( $filter_sr->($value, $self->{$field}{$key}[$i]) ) {
                splice @{$self->{$field}{$key}}, $i, 1;
                next INDEX;
              }
            }
          }
        }
      };
  }

  $class->install_methods (%methods);
}

# end of Class::MethodMaker::hash_of_lists
1;
